package com.muyu.netty.operate;


import com.muyu.common.Config;
import com.muyu.utils.CalculateCheckDigit;
import com.muyu.utils.ConversionUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * @author 牧鱼
 * @Classname NettyClient
 * @Description TODO
 * @Date 2021/7/30
 */
public class NettyClientMsg {

    private static final Logger log = LoggerFactory.getLogger(NettyClientMsg.class);

    /**
     * 发送消息
     * @param msg
     */
    public static void sendMsg(String msg){
        log.info("发送消息：{}",msg);
        //得到16进制报文
        String sHex = ConversionUtil.strToSixteen(msg);
        //计算校验和
        String makeCheck = CalculateCheckDigit.makeCheck(sHex);
        //拼接报文 - 起始位
        StringBuilder sb = new StringBuilder(Config.MSG_START);
        //拼接报文 - 数据位
        sb.append(sHex);
        //拼接报文 - 校验位
        sb.append(makeCheck).append(" ");
        //拼接报文 截止位
        sb.append(Config.MSG_END);
        Config.ctx.writeAndFlush(sb.toString() + Config.DATA_PACK_SEPARATOR);
    }

    /**
     * 销毁netty
     */
    public static void destroy(){
        log.info("发送断开连接消息："+Config.NETTY_CLOSE);
        sendMsg(Config.NETTY_WILL_CLOSE + Config.VIN);
        Config.ctx = null;
    }

}
